#define DMA_WRITE(x, y) *(volatile uint32_t *)(ts73x0dma->dmaregs + M2M_OFFSET_ ## x) = (y)
#define DMA_READ(x) *(volatile uint32_t *)(ts73x0dma->dmaregs + M2M_OFFSET_ ## x)

#define EP9302_DMA_REGS         0x80000140
#define SYSCONFPGA_BASE         0x600FF080
#define FPGA_REGS               0x600FF000

/* ep93xx DMA register constants */
#define DMA_CONTROL        0
#define DMA_INTERRUPT      1
#define DMA_STATUS         3
#define DMA_BCR0           4
#define DMA_BCR1           5
#define DMA_SAR_BASE0      6
#define DMA_SAR_BASE1      7
#define DMA_SAR_CURRENT0   9
#define DMA_SAR_CURRENT1  10
#define DMA_DAR_BASE0     11
#define DMA_DAR_BASE1     12
#define DMA_DAR_CURRENT0  13
#define DMA_DAR_CURRENT1  15

#define DMA_M2M_1_SIZE          0x40

#ifndef DMA_OFFSET
#define DMA_OFFSET              0x000000
#define DMA_BASE                (0x80000000|DMA_OFFSET)
#define DMAMM_0_CONTROL         (DMA_BASE+0x0100)
#define DMAMM_1_CONTROL         (DMA_BASE+0x0140)
#define DMA_M2M_0_BASE          DMAMM_0_CONTROL
#define DMA_M2M_1_BASE          DMAMM_1_CONTROL
#define M2M_OFFSET_CONTROL      0x0000
#define M2M_OFFSET_INTERRUPT    0x0004
#define M2M_OFFSET_STATUS       0x000C
#define M2M_OFFSET_BCR0         0x0010
#define M2M_OFFSET_BCR1         0x0014
#define M2M_OFFSET_SAR_BASE0    0x0018
#define M2M_OFFSET_SAR_BASE1    0x001C
#define M2M_OFFSET_SAR_CURRENT0 0x0024
#define M2M_OFFSET_SAR_CURRENT1 0x0028
#define M2M_OFFSET_DAR_BASE0    0x002C
#define M2M_OFFSET_DAR_BASE1    0x0030
#define M2M_OFFSET_DAR_CURRENT0 0x0034
#define M2M_OFFSET_DAR_CURRENT1 0x003C
#endif
