#include <linux/init.h>
#include <linux/sched.h>
#include <linux/kernel.h> 
#include <linux/errno.h>      
#include <linux/timer.h>
#include <linux/types.h>        
#include <linux/kdev_t.h>
#include <linux/vmalloc.h>
#include <linux/irq.h>
#include <linux/interrupt.h>
#include <linux/slab.h>
#include <linux/mm.h>
#include <asm/io.h>
#include <asm/arch/hardware.h>
#include <asm/atomic.h>
#include <asm/semaphore.h>
#include <asm/current.h>
#include <linux/delay.h>
#include <linux/dma-mapping.h>

#include <linux/mtd/mtd.h>
#include <linux/mtd/nand.h>
#include <linux/mtd/partitions.h>

#include "ts73xx_dma.h"

struct ts73x0dma_dev {
	volatile unsigned long dmaregs;
	volatile unsigned long sysconfpga;
	volatile unsigned short *fpgaregs;
	struct semaphore sem;
	wait_queue_head_t qdma;
	int irq;
};

static int buf_size = 4096;	//1 page
static dma_addr_t dmaaddr;
static u_char *dmabuf;
//DECLARE_COMPLETION(dma_completion);

static struct ts73x0dma_dev *ts73x0dma = NULL;
/*
static irqreturn_t ts73x0_int_handler(int irq, void *vidp)
{
	struct ts73x0dma_dev *dev = (struct ts73x0dma_dev *)vidp;
	DMA_WRITE(INTERRUPT, 0x0);
	complete(&dma_completion);
	BUG_ON(irq != dev->irq);
	return IRQ_HANDLED;
}
*/
int dma_op (unsigned long dev_addr, unsigned long v_addr, unsigned int len, short rw) {
/*
	if (down_interruptible(&ts73x0dma->sem)) {
		return -ERESTARTSYS;
	}
*/
  static int ii = 0;
  static int in_func = 0;
  volatile short testy;
  int n,n2;
  volatile unsigned short *dmabuf2 = dmabuf;
  // 0x1085200
  if (in_func) printk("RE-ENTERED dma_op!\n");
  in_func = 1;

	DMA_WRITE(CONTROL, 0x01085220); DMA_READ(CONTROL);
	ts73x0dma->fpgaregs[12] = dev_addr; //select NAND/SD

  // temp CORRUPTION test
	/*
  if (rw == SD_READ) {
    int j,i=0;
    printk("debug: len=%d, vaddr=%X, dev_addr=%X\n",len,v_addr,dev_addr);
    ts73x0dma->fpgaregs[8] = (len/2)|(1<<12);
    while (!(DMA_READ(STATUS) & 0x200) && ++i < 10000000);
    if (i == 10000000) printk("timeout\n"); else printk("{%d}",i);
    // wait for bit 13, offset C (from same base that SAR_BASE0 uses, see p252-255 of ep9301 guide
    //M2P (ch 0 Tx) is DMA_BASE is 0x8000_0000
    //M2M (ch 1) is EP9302_DMA_REGS is 0x8000_0140
    for (i=0;i<len/2;i++) {
      j=0;
      while (!(DMA_READ(STATUS) & 0x200) && ++j < 10000000);
      if (j == 10000000) printk("timeout\n"); else printk("{%d}",i);
      ((unsigned short *)v_addr)[i] = ts73x0dma->fpgaregs[0x10];
    }
    return 0;
  }
	*/

	if(rw == MTD_READ) {
		ts73x0dma->fpgaregs[8] = (len/2)|(1<<12);
		DMA_WRITE(INTERRUPT, DMA_READ(INTERRUPT) | (1<<1)); 
		DMA_WRITE(DAR_BASE0, dmaaddr);	//phys address
		DMA_WRITE(SAR_BASE0, 0x600ff020);
		DMA_WRITE(BCR0, len);
		DMA_WRITE(CONTROL, 0x01085208); DMA_READ(CONTROL);

		while (!(DMA_READ(STATUS) & 0x40));

		DMA_WRITE(STATUS, 0x0);	
		DMA_WRITE(INTERRUPT, 0x0);
		memcpy((unsigned char *)v_addr, dmabuf, len);
	} else if(rw == SD_READ || rw == SD_WRITE) {
		if(rw == SD_WRITE) {
			ts73x0dma->fpgaregs[8] = (len/2);
			DMA_WRITE(INTERRUPT, DMA_READ(INTERRUPT) | (1<<1)); 
			DMA_WRITE(DAR_BASE0, 0x600ff020);
			DMA_WRITE(SAR_BASE0, dmaaddr);
		}else if (rw == SD_READ) {
		  int i;
		  for (i=0;i<len;i++) dmabuf[i] = 0xFF;
		  //printk("dma:%X %ld %d\n",v_addr,dmaaddr,len);
    			ts73x0dma->fpgaregs[8] = (len/2)|(1<<12);
			DMA_WRITE(INTERRUPT, DMA_READ(INTERRUPT) | (1<<1)); 
    			DMA_WRITE(SAR_BASE0, 0x600ff020);
			DMA_WRITE(DAR_BASE0, dmaaddr);
  		}

		DMA_WRITE(BCR0, len);
		DMA_WRITE(CONTROL, 0x01085228);
		//DMA_WRITE(CONTROL, DMA_READ(CONTROL) | 0x08);

		n=8;
		while (!(DMA_READ(STATUS) & 0x40)) {
		  unsigned short val;

		  //n2 = 8;
		  if (n < len/2) {
		  restart:
		    val = dmabuf2[n];
		    if (val != 0xFFFF) {
		      if (val == 0x00E8) {
			ts73x0dma->fpgaregs[0xA0/2] = 0x25F8;
			ts73x0dma->fpgaregs[0xA0/2] = 0xE8;
			printk("trace--->:%d\n",n);
		      }
		      n += 16;
		      if (n < len/2 /* && --n2 > 0 */) {
			goto restart;
		      }
		    }
		  }
		  testy = ts73x0dma->fpgaregs[0xA0/2];
		}

		DMA_WRITE(STATUS, 0x0);	
		DMA_WRITE(INTERRUPT, 0x0);
		
		{
		  int i,j,min,max;

		  for (i=0;i<len;i+=2) {
		    if (((unsigned char *)(dmabuf+i))[0] == 0xE8
			&& ((unsigned char *)(dmabuf+i))[1] == 0x00) {
		      ts73x0dma->fpgaregs[0xA0/2] = 0x25F8;
		      ts73x0dma->fpgaregs[0xA0/2] = 0xE8;
		      printk("o1 %d %d/%d\n",i,2*n,len);
		      
		      if (ii > 512 && i < n) {
			
		    //printk("---------------- GOT IT---------------\n");
		    min = i - 16;
		    max = i + 16;
		    if (min < 0) min = 0;
		    if (max >= len) max = len-1;
		    for (j=min;j<max;j++) {
		      printk("%02X ",((unsigned char *)dmabuf)[j]);
		      if (j % 16 == 15) {
			/* // OPEN SUBCOMMENT
			int k=j-15;

			for (;k<=j;k++) {
			  if (((unsigned char *)dmabuf)[k] < 32 || ((unsigned char *)dmabuf)[k] > 127) {
			    printk("~");
			  } else {
			    printk("%c",((unsigned char *)dmabuf)[k]);
			  }
			}
			// CLOSE SUBCOMMENT */
			printk("\n");
		      }
		    }
		    printk("\nlen=%d\n",len);

		     
		      }
		    }
		  }
		}

		++ii;
		memcpy((unsigned char *)v_addr, dmabuf, len);
		/*
		{
		  int i;

		  for (i=0;i<len;i+=2) {
		    if (((unsigned char *)(v_addr+i))[0] == 0xE8
			&& ((unsigned char *)(v_addr+i))[1] == 0x00) {
		      printk("o2 %d\n",i);
		    }
		  }
		}
		*/
	}

//	up(&ts73x0dma->sem);
	in_func = 0;
	return 0;
}
EXPORT_SYMBOL(dma_op);

static int __init dma_bus_init(void)
{
	struct ts73x0dma_dev *dev = NULL;
	dev = kmalloc(sizeof (struct ts73x0dma_dev), GFP_KERNEL);
	memset (dev, 0, sizeof (struct ts73x0dma_dev));
	dev->dmaregs = (unsigned long) __ioremap(DMA_M2M_1_BASE, DMA_M2M_1_SIZE, 0);
	dev->sysconfpga = (unsigned long)__ioremap(SYSCONFPGA_BASE, 0xFF, 0);
	dev->fpgaregs = (unsigned short *)__ioremap(FPGA_REGS, 0xFF, 0);
	init_MUTEX(&dev->sem);
	//init_waitqueue_head(&dev->qdma);
	//dev->irq = IRQ_EP93XX_DMAM2M1;	//DMA_M2M1 = IRQ 18
	//request_irq(dev->irq, ts73x0_int_handler, SA_INTERRUPT, NULL, dev);
	dmabuf = dma_alloc_coherent(NULL, buf_size, &dmaaddr, GFP_KERNEL);

	if(NULL == dmabuf) {
		printk("tsdma.c: unable to allocate buffer\n");
		//free_irq(dev->irq, dev);
		return -1;
	} else memset(dmabuf, 0, buf_size);

	ts73x0dma = dev;
	return 0;
}
subsys_initcall(dma_bus_init);
